/* Verbs */

	% transitive singular verbs
		verb(transitive, single, chase) --> [chases].
		verb(transitive, single, kiss)  --> [kisses].
		verb(transitive, single, throw) --> [throws].

	% transitive plural verbs
		verb(transitive, plural, chase)  --> [chase].
		verb(transitive, plural, kiss)   --> [kiss].
		verb(transitive, plural, throw)  --> [throw].


	% intransitive singular verbs
		verb(intransitive, single, run)  --> [runs].
		verb(intransitive, single, walk) --> [walks].

	% intransitive plural verbs
		verb(intransitive, plural, run)  --> [run].
		verb(intransitive, plural, walk) --> [walk].



/* nouns */

	% animate singular nouns
		noun(animate, single, man)   --> [man].
		noun(animate, single, woman) --> [woman].
		noun(animate, single, boy)   --> [boy].
		noun(animate, single, girl)  --> [girl].
		noun(animate, single, dog)   --> [dog].
		noun(animate, single, cat)   --> [cat].

	% animate plural nouns
		noun(animate, plural, man)   --> [men].
		noun(animate, plural, woman) --> [women].
		noun(animate, plural, boy)   --> [boys].
		noun(animate, plural, girl)  --> [girls].
		noun(animate, plural, dog)   --> [dogs].
		noun(animate, plural, cat)   --> [cats].


	% inanimate singular nouns
		noun(inanimate, single, ball)  --> [ball].
		noun(inanimate, single, doll)  --> [doll].
		noun(inanimate, single, stick) --> [stick].

	% inanimate plural nouns
		noun(inanimate, plural, ball)  --> [balls].
		noun(inanimate, plural, doll)  --> [dolls].
		noun(inanimate, plural, stick) --> [sticks].



/* quantifiers */

	% singular quantifiers
		quantifier(single, exists) --> [a].
		quantifier(single, all)    --> [every].

	% plural quantifiers
		quantifier(plural, all)    --> [all].
		quantifier(plural, exists) --> [some].



/* adjectives */
	adjective(black)     --> [black].
	adjective(big)	     --> [big].
	adjective(beautiful) --> [beautiful].



/* adjective/noun phrases*/
	% adjective used
		adj_noun(ANIM, SP, VAR, and(A(VAR),N(VAR)) ) --> adjective(A), noun(ANIM, SP, N).

	% adjective not used
		adj_noun(ANIM, SP, VAR, N(VAR) ) --> noun(ANIM, SP, N).



/* noun phrases */

	% noun with a quantifier.
		noun_phrase(SP, ANIM, Q, VAR, NP) --> quantifier(SP, Q), adj_noun(ANIM, SP, VAR, NP).

	% plural noun without a quantifier.
		noun_phrase(plural, ANIM, all, VAR, NP) --> adj_noun(ANIM, plural, VAR, NP).



/* Verb Phrase */

	% transitive verb phrase.
		verb_phrase(SP, Q(y,NP,VERB(x,y)) ) --> verb(transitive, SP, VERB),	
							  noun_phrase(_, _, Q, y, NP).

			% dont care about quantity / animity in noun-phrase
			% subject of verbphrase is 'y' so this is passed as the variable.

	% intransitive verb phrase.
		verb_phrase(SP, VERB(x))        --> verb(intransitive, SP, VERB).



/* Sentence */

	sentence( s(Q1(x,NP, VP )) ) --> noun_phrase(SP, animate, Q1, x, NP),
							 verb_phrase(SP, VP).

			 % first subject 'x' must be animate.

