/* Verbs */

	% transitive singular verbs
		verb(transitive, single, vb(chases)) --> [chases].
		verb(transitive, single, vb(kisses)) --> [kisses].
		verb(transitive, single, vb(throws)) --> [throws].

	% transitive plural verbs
		verb(transitive, plural, vb(chase))  --> [chase].
		verb(transitive, plural, vb(kiss))   --> [kiss].
		verb(transitive, plural, vb(throw))  --> [throw].


	% intransitive singular verbs
		verb(intransitive, single, vb(runs)) --> [runs].
		verb(intransitive, single, vb(walks))  --> [walks].

	% intransitive plural verbs
		verb(intransitive, plural, vb(run))    --> [run].
		verb(intransitive, plural, vb(walk))   --> [walk].



/* nouns */

	% animate singular nouns
		noun(animate, single, n(man))   --> [man].
		noun(animate, single, n(woman)) --> [woman].
		noun(animate, single, n(boy))   --> [boy].
		noun(animate, single, n(girl))  --> [girl].
		noun(animate, single, n(dog))   --> [dog].
		noun(animate, single, n(cat))   --> [cat].

	% animate plural nouns
		noun(animate, plural, n(men))   --> [men].
		noun(animate, plural, n(women)) --> [women].
		noun(animate, plural, n(boys))  --> [boys].
		noun(animate, plural, n(girls)) --> [girls].
		noun(animate, plural, n(dogs))  --> [dogs].
		noun(animate, plural, n(cats))  --> [cats].


	% inanimate singular nouns
		noun(inanimate, single, n(ball))  --> [ball].
		noun(inanimate, single, n(doll))  --> [doll].
		noun(inanimate, single, n(stick)) --> [stick].

	% inanimate plural nouns
		noun(inanimate, plural, n(balls))  --> [balls].
		noun(inanimate, plural, n(dolls))  --> [dolls].
		noun(inanimate, plural, n(sticks)) --> [sticks].



/* quantifiers */

	% singular quantifiers
		quantifier(single, q(a))     --> [a].
		quantifier(single, q(every)) --> [every].

	% plural quantifiers
		quantifier(plural, q(all))   --> [all].
		quantifier(plural, q(some))  --> [some].



/* noun phrases */

	% noun with a quantifier.
		noun_phrase(SP, ANIM, np(Q,N)) --> quantifier(SP, Q), noun(ANIM, SP, N).

	% plural noun without a quantifier.
		noun_phrase(plural, ANIM, N)   --> noun(ANIM, plural, N).



/* Verb Phrase */

	% transitive verb phrase.
		verb_phrase(SP, vp(VERB,NP)) --> verb(transitive, SP, VERB),	
						 noun_phrase(_, _, NP).

			% dont care about quantity / animity in noun-phrase

	% intransitive verb phrase.
		verb_phrase(SP, VERB)        --> verb(intransitive, SP, VERB).



/* Sentence */

	sentence(s(NP_TREE,VP_TREE)) --> noun_phrase(SP, animate, NP_TREE),
					 verb_phrase(SP, VP_TREE).

			 % first subject must be animate.
