
animate_noun(man, men).
animate_noun(woman, women).
animate_noun(boy, boys).
animate_noun(girl, girls).
animate_noun(dog, dogs).
animate_noun(cat, cats).

animate_noun_SP(singular, X) :- animate_noun(X,_).
animate_noun_SP(plural, X)   :- animate_noun(_,X).


inanimate_noun(ball, balls).
inanimate_noun(doll, dolls).
inanimate_noun(stick, sticks).

inanimate_noun_SP(singular, X) :- inanimate_noun(X,_).
inanimate_noun_SP(plural, X) :- inanimate_noun(_,X).


transitive_verb(chases, chase).
transitive_verb(kisses, kiss).
transitive_verb(throws, throw).

transitive_verb_SP(singular, X) :- transitive_verb(X,_).
transitive_verb_SP(plural, X) :- transitive_verb(_,X).


intransitive_verb(runs, run).
intransitive_verb(walks, walk).

intransitive_verb_SP(singular, X) :- intransitive_verb(X,_).
intransitive_verb_SP(plural, X) :- intransitive_verb(_,X).


quantifier(some, plural).
quantifier(every, singular).
quantifier(all, plural).
quantifier(a, singular).


animate_noun_phrase(SP,X,Y) :- quantifier(X,SP), animate_noun_SP(SP,Y).
inanimate_noun_phrase(SP,X,Y) :- quantifier(X,SP), inanimate_noun_SP(SP,Y).

transitive_phrase(SP, A,B,C) :- animate_noun_phrase(SP, A,B), transitive_verb_SP(SP,C).

intransitive_phrase(A,B,C) :- animate_noun_phrase(SP, A,B), intransitive_verb_SP(SP, C).


/*transitive-animate sentance*/
sentance(A,B,C,X,Y) :- transitive_phrase(SP1, A,B,C), animate_noun_phrase(SP2, X,Y).

/*transitive-inanimate sentance*/
sentance(A,B,C,X,Y) :- transitive_phrase(SP1, A,B,C), inanimate_noun_phrase(SP2, X,Y).

/*intransitive sentance*/
sentance(A,B,C) :- intransitive_phrase(A,B,C).


sentance(B,C,X,Y) :- sentance(all,B,C,X,Y).	/* transitive-animate/inanimate sentance
						   begining quantifier implied 'all' */

sentance(A,B,C,Y) :- sentance(A,B,C,all,Y).	/* transitive-animate/inanimate sentance
						   ending quantifier implied 'all' */

sentance(B,C,Y) :- sentance(all,B,C,all,Y).	/* transitive-animate/inanimate sentance
						   begining and ending quantifier implied 'all' */

sentance(B,C) :- sentance(all, B,C).			/* intransitive sentance
						   begining quantifier implied 'all' */














/* print(A),print(' '),print(B),print(' '),print(C),print(' '),print(X),print(' '),print(Y),print('.'),nl. */
