% Allow response to be dynamic
	:-dynamic(response/2).


% what numbers are we allowed in the sequence?
	what(1).
	what(2).
	what(3).
	what(4).
	what(5).


% systematically generate all possible guesses
	generate_move([A,B,C,D,E]) :-	what(A),
					what(B),
					what(C),
					what(D),
					what(E).


% calculate left and right values from a code-item and a guess-item
	value(CH, GH, L, R) :-  ((CH<GH -> L = 1);L=0),
				((CH>GH -> R = 1);R=0).


% calculate left and right values from a complete code and a complete guess (base-case)
	val([CH], [GH], L, R) :- value(CH, GH, L, R).


% calculate left and right values from a complete code and a complete guess (recursive-case)
	val([CH|CT], [GH|GT], L, R) :-  val(CT, GT, L2, R2),
					value(CH, GH, L1, R1),
					L is L1+L2,
					R is R1+R2.


% play the game for a given code.
% First remove all items from the database.
% Generate a move, then filter it to see if it is a worthy guess.
% If it is then ask if it is the code.
% If it is the code then the game is won.
% If it is'nt the code then put the guess in the database and fila, ie try another move.

	play(Code) :-	retractall(response(_,_)),	% empty the response database
			generate_move(M),		% generate a move
			filter(M),			% Is it worthy?
			val(M,Code,L,R),		% It is, so get its values (L and R)
			(L==0, R==0 ->					% Is it right?
				(					% YES
					write('congratulations'),	% game completed
					nl,
					write('The code was: '),
					display(M),
					nl
				);
				(					% NO
					assert(response(M,L-R)),	% stick guess with L-R in database
					write('guessing '),
					display(M),
					nl,
					fail				% fail this attempt
				)					% and try another guess
			).


% The filter - For the given guess:
% check it against all entries in the database
% as if the entries in the database were the real code.
% If for all database entries the value L-R matches then it is a valid guess,
% otherwise its not

	filter(M) :- forall(response(S,L-R), val(S,M,L,R)).


